<?php

namespace EventPortal\Domain\Agenda;

use Illuminate\Support\Arr;

class SessionKeyMap
{
    /** @var array<string> */
    public static $map = [
        'id' => 'id',
        'name' => 'session-name',
        'description' => 'session-description',
        'starting_at' => 'session-start-time',
        'ending_at' => 'session-end-time',
        'location' => 'session-location',
        'event_speaker_id' => 'session-speakers',
        'event_venue_id' => 'session-venue',
    ];

    public static function getBrowserKeyFromDatabase(string $key): string
    {
        return Arr::get(self::$map, $key, $key);
    }

    public static function getDatabaseKeyFromBrowser(string $key): string
    {
        return array_search($key, self::$map);
    }
}
