<?php

namespace EventPortal\Domain\Util\Modal;

use Illuminate\Support\Arr;

abstract class Modal
{
    /** @var string */
    public $type;

    public $context;

    public $content;

    public $buttons = [];

    public function __construct(string $type)
    {
        $this->type = $type;
    }

    /**
     * @param null|mixed $content
     */
    public function content($content = null): self
    {
        $this->content = $content;

        return $this;
    }

    public function buttons(?callable $buttons = null): self
    {
        $this->buttons[] = $buttons ?? [];

        return $this;
    }

    protected function resolve(): void
    {
        if ($this->buttons === []) {
            return;
        }

        $buttons = array_map(function ($button) {
            return app()->call($button, Arr::wrap($this->context));
        }, $this->buttons);

        $this->buttons = array_merge(...$buttons);
    }
}
