<?php

namespace EventPortal\Http\Middleware\Event;

use Closure;
use EventPortal\Contracts\Event;
use EventPortal\Domain\Event\ViewableStatus;
use Illuminate\Http\Request;
use Illuminate\Http\Response;

class InViewableStatus
{
    /**
     * @return mixed
     */
    public function handle(Request $request, Closure $next)
    {
        abort_unless($this->eventIsInViewableStatus($request->event), Response::HTTP_NOT_FOUND);

        return $next($request);
    }

    private function eventIsInViewableStatus(Event $event): bool
    {
        return ViewableStatus::contains($event->status);
    }
}
